package cds;

import java.util.concurrent.*;
import java.util.concurrent.atomic.AtomicInteger;
/**
 *
 * @author alessio
 */
public class ThreadStarvationLivelockTest {
    static final int NUMTASKS=10;
    static final int POOLSIZE=5;
    static final int INITVALUE=-6; //initial number for the shared counter
    private ExecutorService myExecutor;
    private IncClassBusy[] myTasks;
    
    public ThreadStarvationLivelockTest(ExecutorService exc) {
        myExecutor = exc;       
        // all the tasks are created
        myTasks = new IncClassBusy[NUMTASKS];
        for (int i=0; i<myTasks.length; myTasks[i++]=new IncClassBusy());  
    }
    
    private void runAll(){
        for(Runnable t: myTasks)
            myExecutor.execute(t);
        myExecutor.shutdown();
    }
    
    public static void main(String[] arg){
        ThreadStarvationLivelockTest myInst=
            new ThreadStarvationLivelockTest(Executors.newFixedThreadPool(POOLSIZE));
        
        myInst.runAll();
    }



    static class IncClassBusy implements Runnable{
        
        private static AtomicInteger c = new AtomicInteger(INITVALUE);

        public void IncClassBusy(){        
        }

        @Override
        public void run() {
            int id = c.getAndIncrement()-INITVALUE;
            
            //start message
            String msg="";
            for (int i=0; i++<id; msg+="  ");
            msg+="Task #"+Integer.toString(id)+": STARTED!";
            System.out.println(msg);
            
            while(c.get()<0) {} // busy waiting
            
            //end message
            msg="";
            for (int i=0; i++<id; msg+="  ");
            msg+="Task #"+Integer.toString(id)+": DONE!";
            System.out.println(msg);
        }
    }
}
